package com.yihaomen.common.dao;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.Map;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.beans.factory.annotation.Autowired;

import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.security.access.ConfigAttribute;
import org.springframework.security.access.SecurityConfig;
import org.springframework.stereotype.Repository;

import com.yihaomen.common.domain.SysResource;

@Repository
public class ResourcesDao {
	
	@Autowired
	private JdbcTemplate jdbcTemplate;

	private static final Log log = LogFactory.getLog(UserInfoDao.class);

	public ResourcesDao() {
		System.out.println("加载ResourcesDao..." + jdbcTemplate);
	}

	public List<SysResource> findAll() {
		try {
			List<SysResource> resourceList = new ArrayList<SysResource>();
			List<Map<String, Object>> resources = jdbcTemplate
					.queryForList("select * from sys_resource");
			
			for (Map<String, Object> map : resources) {
				SysResource r = new SysResource();
				r.setId(Integer.valueOf(map.get("id").toString()));
				r.setName(map.get("name").toString());
				r.setType(map.get("type").toString());
				r.setResource(map.get("resource").toString());
				r.setDescription(map.get("description").toString());
				resourceList.add(r);
			}

			return resourceList;
		} catch (RuntimeException re) {
			log.error("find all resource failed " + re);
			throw re;
		}
	}

	// 加载资源与对应的权限
	public Collection<ConfigAttribute> loadRoleByResource(String url) {
		try {
			String sql = "select ro.name as role,re.resource as url "
					+ "from sys_role ro join sys_resource_role rr on ro.id=rr.role_id "
					+ "join sys_resource re on re.id=rr.resc_id "
					+ "where re.resource='" + url + "'";
			List<Map<String, Object>> authList = jdbcTemplate.queryForList(sql);
			Collection<ConfigAttribute> auths = new ArrayList<ConfigAttribute>();
			
			for(Map<String, Object> map:authList){
				ConfigAttribute auth = new SecurityConfig(map.get("role").toString());
				auths.add(auth);
			}
			
			return auths;
		} catch (RuntimeException re) {
			log.error("find roles by url failed " + re);
			throw re;
		}
	}

} 